Index: /trunk/src/uvmat.m
===================================================================
--- /trunk/src/uvmat.m	(revision 353)
+++ /trunk/src/uvmat.m	(revision 354)
@@ -2312,25 +2318,101 @@
                 end
             end
-        end
-        test_keepdata_1=0;% test for keeping the previous stored data if the input files are unchanged
-        if ~isequal(NomType_1,'*')%in case of a series of files (not avi movie)
-            if isfield(UvData,'filename_1')&& isfield(UvData,'VelType_1') && isfield(UvData,'FieldName_1')
-                test_keepdata_1= strcmp(filename_1,UvData.filename_1) && strcmp(VelType_1,UvData.VelType_1) && strcmp(FieldName_1,UvData.FieldName_1);
-            end
-        end
-        if test_keepdata_1
-            Field{2}=UvData.Field_1;
-        else
-            ParamIn.FieldName=FieldName_1;
-            ParamIn.VelType=VelType_1;
-            ParamIn.GUIName='get_field_1';
-            [Field{2},ParamOut_1,errormsg] = read_field(Name,FileType_1,ParamIn,num_i1);
-            if ~isempty(errormsg)
-                errormsg=['error in reading ' FieldName_1 ' in ' filename_1 ': ' errormsg];
+        case 'video'
+            Name=UvData.MovieObject{2};
+        case 'vol' %TODO: update
+            if isfield(UvData.XmlData,'Npy') && isfield(UvData.XmlData,'Npx')
+                ParamIn.Npy=UvData.XmlData.Npy;
+                ParamIn.Npx=UvData.XmlData.Npx;
+            else
+                errormsg='Npx and Npy need to be defined in the xml file for volume images .vol';
                 return
             end
-            UvData.Field_1=Field{2}; %store the second field for possible use at next RUN
-        end
-    end
+    end
+%     if strcmp(get(handles.FileExt_1,'Visible'),'on')
+%         FileExt_1=get(handles.FileExt_1,'String');
+%     else
+%         FileExt_1=get(handles.FileExt,'String');%read the file extension for the first series (case of veltype comparison within a single file)
+%     end
+    NomType_1=get(handles.NomType_1,'String');
+%     %         NomType_1=get(handles.FileIndex_1,'UserData');
+%     if isequal(Ext_1,'.nc')||isequal(Ext_1,'.cdf')
+%         FileType_1='netcdf';
+%     elseif isfield(UvData,'MovieObject_1')
+%         Name=UvData.MovieObject_1;
+%         FileType_1='movie';
+%     elseif isequal(lower(Ext_1),'.avi')
+%         FileType_1='avi';
+%     elseif isequal(lower(Ext_1),'.vol')
+%         FileType_1='vol';
+%         if isfield(UvData.XmlData_1,'Npy') && isfield(UvData.XmlData_1,'Npx')
+%             ParamIn.Npy=UvData.XmlData_1.Npy;
+%             ParamIn.Npx=UvData.XmlData_1.Npx;
+%         else
+%             errormsg='Npx and Npy need to be defined in the xml file for volume images .vol';
+%             return
+%         end
+%     else
+%         if length(Ext_1)>=2
+%             form=imformats(Ext_1(2:end));
+%             if ~isempty(form)% if the extension corresponds to an image format recognized by Matlab
+%                 if isequal(NomType_1,'*');
+%                     FileType_1='multimage';
+%                 else
+%                     FileType_1='image';
+%                 end
+%             end
+%         end
+%     end
+%     if strcmp(FileType_1,'netcdf')
+%         list_fields=get(handles.Fields_1,'String');% list menu fields
+%         index_fields=get(handles.Fields_1,'Value');% selected string index
+%         FieldName_1= list_fields{index_fields}; % selected field
+%         if ~isequal(FieldName_1,'get_field...')% read the field names on the interface get_field...
+%             VelType_1='';
+%             if get(handles.FixVelType,'Value')
+%                 VelTypeList=get(handles.VelType_1,'String');
+%                 index=get(handles.VelType_1,'Value');
+%                 VelType_1=VelTypeList{index};
+%             end
+%         end
+%         if strcmp(VelType_1,'*')% free veltype choice
+%             VelType_1=[];
+%         elseif strcmp(VelType_1,'"')% veltype the same as for the first field
+%             if isempty(VelType)
+%                 VelType_1=[];
+%             else
+%                 VelType_1=VelType;
+%             end
+%         end
+%         if strcmp(FieldName_1,'velocity')
+%             list_code=get(handles.ListColorCode,'String');% list menu fields
+%             index_code=get(handles.ListColorCode,'Value');% selected string index
+%             if  ~strcmp(list_code{index_code},'black') &&  ~strcmp(list_code{index_code},'white')
+%                 list_code=get(handles.ListColorScalar,'String');% list menu fields
+%                 index_code=get(handles.ListColorScalar,'Value');% selected string index
+%                 ParamIn.ColorVar= list_code{index_code}; % selected field
+%             end
+%         end
+%     end
+    test_keepdata_1=0;% test for keeping the previous stored data if the input files are unchanged
+    if ~isequal(NomType_1,'*')%in case of a series of files (not avi movie)
+        if isfield(UvData,'filename_1')&& isfield(UvData,'VelType_1') && isfield(UvData,'FieldName_1')
+            test_keepdata_1= strcmp(filename_1,UvData.filename_1) && strcmp(VelType_1,UvData.VelType_1) && strcmp(FieldName_1,UvData.FieldName_1);
+        end
+    end
+    if test_keepdata_1
+        Field{2}=UvData.Field_1;
+    else
+        ParamIn.FieldName=FieldName_1;
+        ParamIn.VelType=VelType_1;
+        ParamIn.GUIName='get_field_1';
+        [Field{2},ParamOut_1,errormsg] = read_field(Name,FileType_1,ParamIn,num_i1);
+        if ~isempty(errormsg)
+            errormsg=['error in reading ' FieldName_1 ' in ' filename_1 ': ' errormsg];
+            return
+        end
+        UvData.Field_1=Field{2}; %store the second field for possible use at next RUN
+    end
+    %     end
 end
 
@@ -2346,7 +2428,6 @@
 %% update the display menu for the first velocity type (first menuline)
 test_veltype=0;
-if ~isequal(FileType,'netcdf')|| isequal(FieldName,'get_field...')
-    set(handles.VelType,'Visible','off')
-else
+% if ~isequal(FileType,'netcdf')|| isequal(FieldName,'get_field...')
+if (strcmp(FileType,'civx')||strcmp(FileType,'civdata'))&& ~strcmp(FieldName,'get_field...')
     test_veltype=1;
     set(handles.VelType,'Visible','on')
@@ -2361,4 +2442,6 @@
      set(handles.VelType_1,'String',[{''};menu])
     end
+else
+    set(handles.VelType,'Visible','off')
 end
 field_index=strcmp(ParamOut.FieldName,ParamOut.FieldList);
@@ -2402,5 +2485,6 @@
         set(handles.RootFile_1,'String','"')
         set(handles.SubDir_1,'String','"');
-        [indices]=name_generator('',num_i1,num_j1,'',NomType,1,num_i2,num_j2,'');
+         indices=fullfile_uvmat('','','','',NomType,num_i1,num_i2,num_j1,num_j2);
+        %[indices]=name_generator('',num_i1,num_j1,'',NomType,1,num_i2,num_j2,'');
         set(handles.FileIndex_1,'String',indices)
         set(handles.FileExt_1,'String','"');
@@ -2458,8 +2542,8 @@
 
 %% calculate scalar
-if isequal(FileType,'netcdf') && ~isequal(ParamOut.CivStage,0)%&&~isempty(FieldName)%
+if strcmp(FileType(1:3),'civ') && ~isequal(ParamOut.CivStage,0)%&&~isempty(FieldName)%
     Field{1}=calc_field([{ParamOut.FieldName} {ParamOut.ColorVar}],Field{1});
 end
-if numel(Field)==2 && ~test_keepdata_1 && isequal(FileType_1,'netcdf') && ~isequal(ParamOut_1.FieldName,'get_field...')%&&~isempty(FieldName_1)
+if numel(Field)==2 && ~test_keepdata_1 && isequal(FileType_1(1:3),'civ') && ~isequal(ParamOut_1.FieldName,'get_field...')%&&~isempty(FieldName_1)
     Field{2}=calc_field([{ParamOut_1.FieldName} {ParamOut_1.ColorVar}],Field{2});
 end
@@ -2659,5 +2743,4 @@
 %PlotParam{1}=read_plot_param(handles);%read plotting parameters on the uvmat interfac
 PlotParam{1}=read_GUI(handles.uvmat);
-PlotParam{1}.Coordinates
 if ~isfield(PlotParam{1},'Vectors')
     PlotParam{1}.Vectors.MaxVec=1;
@@ -2959,5 +3042,7 @@
 function record_Callback(hObject, eventdata, handles)
 % [filebase,num_i1,num_j1,num_i2,num_j2,Ext,NomType,SubDir]=read_input_file(handles);
-filename=read_file_boxes(handles);
+[RootPath,SubDir,RootFile,FileIndices,FileExt]=read_file_boxes(handles);
+filename=[fullfile(RootPath,SubDir,RootFile) FileIndices FileExt];
+%filename=read_file_boxes(handles);
 [erread,message]=fileattrib(filename);
 if ~isempty(message) && ~isequal(message.UserWrite,1)
@@ -3105,4 +3190,6 @@
     set(handles.RootFile_1,'Visible','off')
     set(handles.SubDir_1,'Visible','off');
+    set(handles.NomType_1,'Visible','off');
+    set(handles.abs_time_1,'Visible','off')
     set(handles.FileIndex_1,'Visible','off');
     set(handles.FileExt_1,'Visible','off');
@@ -3126,39 +3213,17 @@
 % --- read the data displayed for the input rootfile windows (new): TODO use read_GUI
 
-function [FileName,RootPath,FileBase,FileIndices,FileExt,SubDir]=read_file_boxes(handles)
+function [RootPath,SubDir,RootFile,FileIndices,FileExt]=read_file_boxes(handles)
 %------------------------------------------------------------------------
 InputFile=read_GUI(handles.InputFile);
 RootPath=InputFile.RootPath;
-FileName=InputFile.RootPath; %default
-if ~isempty(InputFile.SubDir)
-    InputFile.SubDir=regexprep(InputFile.SubDir,'/|\','');
-    FileName=fullfile(InputFile.RootPath,InputFile.SubDir);
-end
-if ~isempty(InputFile.RootFile)
-    InputFile.RootFile=regexprep(InputFile.RootFile,'/|\','');
-    FileName=fullfile(FileName,InputFile.RootFile);
-end
-SubDir=InputFile.SubDir;
-% if ~isempty(SubDir) && ~isequal(SubDir,'')
-%     if (isequal(SubDir(1),'/')|| isequal(SubDir(1),'\'))
-%         SubDir(1)=[]; %suppress possible / or \ separator
-%     end
-%     FileName=fullfile(RootPath,SubDir);
-% end
-% RootFile=get(handles.RootFile,'String');
-% if ~isempty(RootFile) && ~isequal(RootFile,'')
-%     if (isequal(RootFile(1),'/')|| isequal(RootFile(1),'\'))
-%         RootFile(1)=[]; %suppress possible / or \ separator
-%     end
-%     FileName=fullfile(FileName,RootFile);
-% end
-FileBase=fullfile(InputFile.RootPath,InputFile.RootFile);
+SubDir=regexprep(InputFile.SubDir,'/|\','');
+RootFile=regexprep(InputFile.RootFile,'/|\','');
 FileIndices=InputFile.FileIndex;
 FileExt=InputFile.FileExt;
-FileName=[FileName InputFile.FileIndex InputFile.FileExt];
+
 
 %------------------------------------------------------------------------
 % ---- read the data displayed for the second input rootfile windows
-function [FileName_1,RootPath_1,FileBase_1,FileIndices_1,FileExt_1,SubDir_1]=read_file_boxes_1(handles)
+function [RootPath_1,SubDir_1,RootFile_1,FileIndex_1,FileExt_1,NomType_1]=read_file_boxes_1(handles)
 %------------------------------------------------------------------------
 RootPath_1=get(handles.RootPath_1,'String'); % read the data from the file1_input window
@@ -3166,24 +3231,17 @@
     RootPath_1=get(handles.RootPath,'String');
 end;
-FileName_1=RootPath_1; %default
 SubDir_1=get(handles.SubDir_1,'String');
 if isequal(get(handles.SubDir_1,'Visible'),'off')|| isequal(SubDir_1,'"')
     SubDir_1=get(handles.SubDir,'String');
 end
+SubDir_1=regexprep(SubDir_1,'\<[\\/]|[\\/]\>','');%suppress possible / or \ separator at the beginning or the end of the string
 RootFile_1=get(handles.RootFile_1,'String');
-SubDir_1=regexprep(SubDir_1,'\<[\\/]|[\\/]\>','');%suppress possible / or \ separator at the beginning or the end of the string
-FileName_1=fullfile(RootPath_1,SubDir_1);
 if isequal(get(handles.RootFile_1,'Visible'),'off') || isequal(RootFile_1,'"')
     RootFile_1=get(handles.RootFile,'String'); 
 end
 RootFile_1=regexprep(RootFile_1,'\<[\\/]|[\\/]\>','');%suppress possible / or \ separator at the beginning or the end of the string
-if numel(RootFile_1)>=1
-    FileName_1=fullfile(FileName_1,RootFile_1);
-end
-FileBase_1=fullfile(RootPath_1,RootFile_1);
-if isequal(get(handles.FileIndex_1,'Visible'),'off') 
-    FileIndices_1=get(handles.FileIndex,'String');
-else
-    FileIndices_1=get(handles.FileIndex_1,'String');
+FileIndex_1=get(handles.FileIndex_1,'String');
+if isequal(get(handles.FileIndex_1,'Visible'),'off')|| isequal(FileIndex_1,'"')
+    FileIndex_1=get(handles.FileIndex,'String');
 end
 FileExt_1=get(handles.FileExt_1,'String');
@@ -3191,6 +3249,8 @@
     FileExt_1=get(handles.FileExt,'String');%read FileExt by default
 end
-FileName_1=[FileName_1 FileIndices_1 FileExt_1];
-
+NomType_1=get(handles.NomType_1,'String');
+if isequal(get(handles.NomType_1,'Visible'),'off') || isequal(NomType_1,'"')
+    NomType_1=get(handles.NomType,'String');%read FileExt by default
+end
 %------------------------------------------------------------------------
 % --- Executes on menu selection Fields
@@ -3204,5 +3264,7 @@
     set(handles.VelType,'visible','off')
     set(handles.VelType_1,'visible','off')
-    filename=read_file_boxes(handles);
+    [RootPath,SubDir,RootFile,FileIndices,FileExt]=read_file_boxes(handles);
+    filename=[fullfile(RootPath,SubDir,RootFile) FileIndices FileExt];
+    %filename=read_file_boxes(handles);
     hget_field=findobj(allchild(0),'name','get_field');
     if ~isempty(hget_field)
@@ -3224,5 +3286,7 @@
 
 %read the rootfile input display
-[FileName,RootPath,FileBase,FileIndices,FileExt]=read_file_boxes(handles);
+[RootPath,SubDir,RootFile,FileIndices,FileExt]=read_file_boxes(handles);
+FileName=[fullfile(RootPath,SubDir,RootFile) FileIndices FileExt];
+% [FileName,RootPath,FileBase,FileIndices,FileExt]=read_file_boxes(handles);
 [tild,tild,tild,i1,i2,j1,j2,tild,NomType]=fileparts_uvmat(['xxx' get(handles.FileIndex,'String') FileExt]);
 % [P,F,str1,str2,str_a,str_b,E,NomType]=name2display(['xxx' get(handles.FileIndex,'String') FileExt]);
@@ -3236,5 +3300,6 @@
         NomTypeNew='_1';
     end
-    imagename=name_generator(FileBase,i1,j1,'.png',NomTypeNew,1,i2,j2,'');
+    imagename=fullfile_uvmat(RootPath,SubDir,RootFile,'.png',NomTypeNew,i1,i2,j1,j2);
+%     imagename=name_generator(FileBase,i1,j1,'.png',NomTypeNew,1,i2,j2,'');
     if ~exist(imagename,'file')
         [FileName,PathName] = uigetfile( ...
@@ -3267,5 +3332,5 @@
 end
 % indices=name_generator('',i1,j1,'',NomTypeNew,1,i2,j2,'');
-indices=fullfile_uvmat('','','',FileExt,NomTypeNew,i1,i2,j1,j2);
+indices=fullfile_uvmat('','','','',NomTypeNew,i1,i2,j1,j2);
 set(handles.FileIndex,'String',indices)
 set(handles.NomType,'String',NomTypeNew)
@@ -3292,4 +3357,10 @@
 function Fields_1_Callback(hObject, eventdata, handles)
 %-------------------------------------------------
+%% read input data
+check_new=~get(handles.SubField,'Value'); %check_new=1 if a second field was not previously entered
+UvData=get(handles.uvmat,'UserData');
+if check_new && isfield(UvData,'XmlData')
+    UvData.XmlData_1=UvData.XmlData;
+end
 list_fields=get(handles.Fields,'String');% list menu fields
 index_fields=get(handles.Fields,'Value');% selected string index
@@ -3298,190 +3369,88 @@
 index_fields=get(handles.Fields_1,'Value');% selected string index
 field_1= list_fields{index_fields(1)}; % selected string for the second field
-if isequal(field_1,'') %remove second field if 'blank' field is selected
+if isequal(field_1,'')||(numel(UvData.FileType)>=2 && strcmp(UvData.FileType{2},'image'))
     set(handles.SubField,'Value',0)
+    check_new=1;
     SubField_Callback(hObject, eventdata, handles)
-    return
-end
-UvData=get(handles.uvmat,'UserData');
-
-%read the rootfile input display
-[FileName,RootPath,FileBase,FileIndices,FileExt_1]=read_file_boxes_1(handles);
-[tild,tild,tild,i1,i2,j1,j2,tild,NomType_1]=fileparts_uvmat(['xxx' get(handles.FileIndex,'String') FileExt_1]);
-% [P,F,str1,str2,str_a,str_b,E,NomType_1]=name2display(['xxx' get(handles.FileIndex,'String') FileExt_1]);
-if isempty(NomType_1)|| strcmp(NomType_1,'')
-    [FileName,RootPath,FileBase,FileIndices,FileExt_1]=read_file_boxes(handles);
-    [tild,tild,tild,i1,i2,j1,j2,tild,NomType_1]=fileparts_uvmat(['xxx' get(handles.FileIndex,'String') FileExt_1]);
- %   [P,F,str1,str2,str_a,str_b,E,NomType_1]=name2display(['xxx' get(handles.FileIndex,'String') FileExt_1]);
-end
-NomTypeNew=NomType_1;%default
-
-set(handles.SubField,'Value',1)%introduce second field
-if isfield(UvData,'XmlData')
-    UvData.XmlData_1=UvData.XmlData;
-end
+    if isempty(field_1)%remove second field if 'blank' field is selected
+        return
+    end
+end
+set(handles.SubField,'Value',1)%state that a second field is now entered
+
+%% read the rootfile input display
+[RootPath_1,SubDir_1,RootFile_1,FileIndex_1,FileExt_1,NomTYpe_1]=read_file_boxes_1(handles);
+filename_1=[fullfile(RootPath_1,SubDir_1,RootFile_1) FileIndex_1 FileExt_1];
+[tild,tild,tild,i1,i2,j1,j2]=fileparts_uvmat(get(handles.FileIndex,'String'));
 set(handles.FileIndex_1,'Visible','on')
 set(handles.FileExt_1,'Visible','on')
-RootPath_1=get(handles.RootPath_1,'String');
-RootFile_1=get(handles.RootFile_1,'String');
-if isempty(RootPath_1)||isequal(RootPath_1,'')
-    set(handles.RootPath_1,'String','"')
-end
-if isempty(RootFile_1) || isequal(RootFile_1,'')
-    set(handles.RootFile_1,'String','"')
-end
-if ~isempty(RootFile_1)&&(isequal(RootFile_1(1),'/')||isequal(RootFile_1(1),'\'))
-    RootFile_1(1)=[];
-end
-
-if isequal(field_1,'get_field...')
-     veltype_handles=[handles.VelType handles.interp1 handles.filter1 handles.civ2 handles.interp2 handles.filter2];
-     set_veltype_display(veltype_handles,0) % unvisible civ buttons
-     filename=read_file_boxes_1(handles);
-     hget_field=findobj(allchild(0),'name','get_field_1');
-     if ~isempty(hget_field)
-         delete(hget_field)
-     end
-     hget_field=get_field(filename);
-     set(hget_field,'name','get_field_1')
-     hhget_field=guidata(hget_field);
-     set(hhget_field.list_fig,'Value',1)
-     set(hhget_field.list_fig,'String',{'uvmat'})
-     set(handles.transform_fct,'Value',1)% no transform by default
-     set(handles.path_transform,'String','')
-    return %no action
-end
-if isequal(field_1,'image') 
-    % transform netc type to the corresponding image type
-    if isequal(NomType_1,'_1-2_1')||isequal(NomType_1,'_1_1-2')|| isequal(NomType_1,'#_ab')|| isequal(NomType_1,'_1-2')
-        UvData.SubDir_1=get(handles.SubDir_1,'String'); %preserve the InputFile.SubDir in memory    
-        if isequal(NomType_1,'_1-2_1')||isequal(NomType_1,'_1_1-2')
-            NomTypeNew='_1_1';
-        elseif isequal(NomType_1,'#_ab')
-            NomTypeNew='#a';
-        elseif isequal(NomType_1,'_1-2')
-            NomTypeNew='_1';
-        end  
-    end
-%     imagename=name_generator(FileBase,i1,j1,'.png',NomTypeNew,1,i2,j2,'');
-    imagename=fullfile_uvmat(RootPath,SubDir,FileName,'.png',NomTypeNew,i1,i2,j1,j2);
-    if ~exist(imagename,'file')
-        [FileName,PathName] = uigetfile( ...
-            {'*.png;*.jpg;*.tif;*.avi;*.AVI;*.vol', ' (*.png, .tif, *.avi,*.vol)';
-            '*.jpg',' jpeg image files'; ...
-            '*.png','.png image files'; ...
-            '*.tif','.tif image files'; ...
-            '*.avi;*.AVI','.avi movie files'; ...
-            '*.vol','.volume images (png)'; ...
-            '*.*',  'All Files (*.*)'}, ...
-            'Pick an image',imagename);
-        % display the selected field and related information
-        imagename=[PathName FileName];
-    end
-    display_file_name_1(hObject, eventdata, handles,imagename)%display the image
-    return
-else
-    set(handles.SubDir_1,'Visible','on')
-    if ~isequal(FileExt_1,'.nc') %find the new NomType if the previous display was not already a netcdf file
-        RootPath_1=get(handles.RootPath_1,'String');
-        RootFile_1=get(handles.RootFile_1,'String');
-        if isempty(RootPath_1)||isequal(RootPath_1,'')
-            set(handles.RootPath_1,'String','"')
-        end
-        if isempty(RootFile_1) || isequal(RootFile_1,'')
-            set(handles.RootFile_1,'String','"')
-        end
-        if ~isempty(RootFile_1)&&(isequal(RootFile_1(1),'/')||isequal(RootFile_1(1),'\'))
-            RootFile_1(1)=[];
-        end
-        filebase_1=fullfile(RootPath_1,RootFile_1);
-        SubDir_1=get(handles.SubDir,'String');
-        if isempty(SubDir_1)||isequal(SubDir_1,'')
-            if isfield(UvData,'SubDir_1')
-                SubDir_1=UvData.SubDir_1;%retrieve previous subdir
-            else
-                SubDir_1='?';
+switch field_1
+    case 'get_field...'
+        %veltype_handles=[handles.VelType handles.interp1 handles.filter1 handles.civ2 handles.interp2 handles.filter2];
+        set_veltype_display(0) % no veltype display
+        %      [RootPath_1,SubDir_1,RootFile_1,FileIndices_1,FileExt_1]=read_file_boxes_1(handles);
+        %      filename=[fullfile(RootPath_1,SubDir_1,RootFile_1) FileIndices_1 FileExt_1];
+        hget_field=findobj(allchild(0),'name','get_field_1');
+        if ~isempty(hget_field)
+            delete(hget_field)
+        end
+        hget_field=get_field(filename_1);
+        set(hget_field,'name','get_field_1')
+        hhget_field=guidata(hget_field);
+        set(hhget_field.list_fig,'Value',1)
+        set(hhget_field.list_fig,'String',{'uvmat'})
+        set(handles.transform_fct,'Value',1)% no transform by default
+        set(handles.path_transform,'String','')
+    case 'image'
+        % transform netc type to the corresponding image type
+        NomType=get(handles.NomType,'string');
+        check_letter=~isempty(regexp(NomType,'[ab|AB]$'));%detect pair label by letter
+        NomType_1=NomType;
+        if check_letter
+            NomType_1=NomType_1(1:end-1);
+        else
+            r=regexp(NomType_1,'.-(?<num2>\d+$','names');
+            if ~isempty(r)
+                NomType_1=regexprep(NomType_1,['-' r.num2],'');
             end
         end
-        str1=get(handles.i1,'String');
-        str_a=get(handles.j1,'String');
-        if isequal(NomType_1,'#_ab')||isequal(NomType_1,'_1-2_1')||isequal(NomType_1,'_1_1-2')||isequal(NomType_1,'_1-2')
-            NomTypeNew=NomType_1;
-        elseif isequal(NomType_1,'#a')
-             [filename, n1,na,n2,nb,SubDir_1]=name_generator(filebase_1, str2num(str1),stra2num(str_a),'.nc','#_ab',0,[],[],SubDir_1);
-             NomTypeNew='#_ab';
-        elseif isequal(NomType_1,'_1_1')
-             [filename,n1,na,n2,nb,SubDir_1]=name_generator(filebase_1,str2num(str1),stra2num(str_a),'.nc','_1-2_1',0,str2num(str1),[],SubDir_1);
-            if idetect==1
-                NomTypeNew='_1-2_1';
-            else
-                NomTypeNew='_1_1-2';
-            end
-        else %for instance avi files or any ima_num series
-            [filename,n1,na,n2,nb,SubDir_1]=name_generator(filebase_1,str2num(str1),stra2num(str_a),'.nc','_1-2',0,str2num(str1),[],SubDir_1);
-            NomTypeNew='_1-2';
-        end            
-        [Path,Name]=fileparts(filebase_1);
-        set(handles.FileExt_1,'String','.nc');
-        if ~isempty(SubDir_1) && ~strcmp(SubDir_1,'''')&& ~strcmp(SubDir_1,'"')&& ~strcmp(SubDir_1(1),'/')
-            SubDir_1=['/' SubDir_1];
-        end
-        set(handles.SubDir_1,'String',SubDir_1);
-    end
-    if isequal(field,'vort') || isequal(field,'div') || isequal(field,'strain')
-        set(handles.VelType_1,'BackgroundColor',[0.702 0.702 0.702]) % put their color to grey
-        set(handles.civ2_1,'BackgroundColor',[0.702 0.702 0.702])
-        set(handles.interp1_1,'BackgroundColor',[0.702 0.702 0.702])
-        set(handles.interp2_1,'BackgroundColor',[0.702 0.702 0.702])
-    elseif isequal(field_1,'more...'); %add new item to the menu
-        set(handles.VelType_1,'BackgroundColor',[0.702 0.702 0.702]) % put their color to grey
-        set(handles.civ2_1,'BackgroundColor',[0.702 0.702 0.702])
-        str=calc_field;%get the list of available scalars by the function calc_scal
-        [ind_answer,v] = listdlg('PromptString','Select a file:',...
-                'SelectionMode','single',...
-                'ListString',str);
-       % edit the choice in the field and action menu
-        scalar=cell2mat(str(ind_answer));
-        menu=update_menu(handles.Fields_1,scalar);
-        set(handles.Fields_1,'String',menu);% store the selected scalar type
-    end
-end
-str1=get(handles.i1,'String');
-str2=get(handles.i2,'String');
-str_a=get(handles.j1,'String');
-str_b=get(handles.j2,'String');
-indices=name_generator('',str2num(str1),stra2num(str_a),'',NomTypeNew,1,str2num(str2),stra2num(str_b),'');
-set(handles.FileIndex_1,'String',indices)
-set(handles.NomType_1,'String',NomTypeNew)
-% set(handles.FileIndex_1,'UserData',NomTypeNew)
-
-%common to Fields_Callback
-if isequal(field,'image')||isequal(field_1,'image')
-    set(handles.TitleNpx,'Visible','on')% visible npx,pxcm... buttons
-    set(handles.TitleNpy,'Visible','on')
-    set(handles.num_Npx,'Visible','on')
-    set(handles.num_Npy,'Visible','on')
-%     set(handles.fix_pair,'Value',0)
-else
-    set(handles.TitleNpx,'Visible','off')% visible npx,pxcm... buttons
-    set(handles.TitleNpy,'Visible','off')
-    set(handles.num_Npx,'Visible','off')
-    set(handles.num_Npy,'Visible','off')
-%     set(handles.fix_pair,'Value',1)
-end
-if isequal(field,'velocity')||isequal(field_1,'velocity');
-    state_vect='on';
-else
-    state_vect='off';
-end 
-if ~isequal(field,'velocity')||(~isequal(field_1,'velocity')&~isequal(field_1,''));
-    state_scal='on';
-else
-    state_scal='off';
-end 
-set(handles.uvmat,'UserData',UvData)
-setfield(handles);% update the field structure ('civ1'....)
-if ~(isfield(UvData,'NewSeries')&&isequal(UvData.NewSeries,1))
-    run0_Callback(hObject, eventdata, handles)
-end
+        imagename=fullfile_uvmat(RootPath_1,'',RootFile_1,'.png',NomType_1,i1,[],j1);
+        if ~exist(imagename,'file')
+            [FileName,PathName] = uigetfile( ...
+                {'*.png;*.jpg;*.tif;*.avi;*.AVI;*.vol', ' (*.png, .tif, *.avi,*.vol)';
+                '*.jpg',' jpeg image files'; ...
+                '*.png','.png image files'; ...
+                '*.tif','.tif image files'; ...
+                '*.avi;*.AVI','.avi movie files'; ...
+                '*.vol','.volume images (png)'; ...
+                '*.*',  'All Files (*.*)'}, ...
+                'Pick an image',imagename);
+            % display the selected field and related information
+            imagename=[PathName FileName];
+        end
+        set(handles.TitleNpx,'Visible','on')% visible npx,pxcm... buttons
+        set(handles.TitleNpy,'Visible','on')
+        set(handles.num_Npx,'Visible','on')
+        set(handles.num_Npy,'Visible','on')
+        display_file_name(hObject, eventdata, handles,imagename,2)%display the imag
+    otherwise
+        if check_new
+            UvData.FileType{2}=UvData.FileType{1};
+            set(handles.FileIndex_1,'String',get(handles.FileIndex,'String'))
+            set(handles.FileExt_1,'String',get(handles.FileExt,'String'))
+        end
+        if ~isequal(field,'image')
+            set(handles.TitleNpx,'Visible','off')% visible npx,pxcm... buttons
+            set(handles.TitleNpy,'Visible','off')
+            set(handles.num_Npx,'Visible','off')
+            set(handles.num_Npy,'Visible','off')
+        end
+        set(handles.uvmat,'UserData',UvData)
+        setfield(handles);% update the field structure ('civ1'....)
+        if ~(isfield(UvData,'NewSeries')&&isequal(UvData.NewSeries,1))
+            run0_Callback(hObject, eventdata, handles)
+        end
+end
+
 
 %------------------------------------------------------------------------
@@ -3502,12 +3471,4 @@
 menu={'civ1';'interp1';'filter1';'civ2';'interp2';'filter2'};
 menu=menu(1:imax);
-% for ibutton=1:imax;
-%     set(handles(ibutton),'Visible','on')  % unvisible civ buttons
-% end
-% % for ibutton=max(imax+1,2):6;
-% for ibutton=imax+1:6;
-%     set(handles(ibutton),'Visible','off')  % unvisible civ buttons
-%     set(handles(ibutton),'Value',0)%unactivate unvisible buttons
-% end
 
 %------------------------------------------------------------------------
@@ -3528,5 +3489,7 @@
 drawnow   
 InputFile=read_GUI(handles.InputFile);
-filename=read_file_boxes(handles);
+[RootPath,SubDir,RootFile,FileIndices,FileExt]=read_file_boxes(handles);
+filename=[fullfile(RootPath,SubDir,RootFile) FileIndices FileExt];
+%filename=read_file_boxes(handles);
 
 index=get(handles.VelType_1,'Value');
@@ -3536,5 +3499,7 @@
         SubField_Callback(hObject, eventdata, handles)
 elseif get(handles.SubField,'Value')% if subfield is already 'on'
-    filename_1=read_file_boxes_1(handles); %read the current second field
+      [RootPath_1,SubDir_1,RootFile_1,FileIndices_1,FileExt_1]=read_file_boxes_1(handles);
+     filename_1=[fullfile(RootPath_1,SubDir_1,RootFile_1) FileIndices_1 FileExt_1];
+    %filename_1=read_file_boxes_1(handles); %read the current second field
 else
      filename_1=filename;% we compare two fields in the same file
@@ -3722,5 +3687,6 @@
 masknumber=num2str(length(list));
 maskindex=get(handles.masklevel,'Value');
-mask_name=name_generator([filebase '_' masknumber 'mask'],maskindex,1,'.png','_i');
+mask_name=fullfile_uvmat(RootPath,SubDir,[RootFile '_' masknumber 'mask'],'.png','_1',maskindex);
+%mask_name=name_generator([filebase '_' masknumber 'mask'],maskindex,1,'.png','_i');
 imflag=uint8(255*(0.392+0.608*flag));% =100 for flag=0 (vectors not computed when 20<imflag<200)
 imflag=flipdim(imflag,1);
@@ -4496,5 +4462,7 @@
 huvmat=get(handles.run0,'parent');
 UvData=get(huvmat,'UserData');
-[xx,xx,FileBase]=read_file_boxes(handles);
+%[xx,xx,FileBase]=read_file_boxes(handles);
+[RootPath,SubDir,RootFile,FileIndices,FileExt]=read_file_boxes(handles);
+FileBase=fullfile(RootPath,RootFile);
  %read the current input file name
 prompt = {'movie file name';'frames per second';'frame resolution (*[512x384] pixels)';'axis position relative to the frame';'total frame number (starting from the current uvmat display)'};
@@ -4594,5 +4562,7 @@
 pos(1)=pos(1)+pos(3)-0.311+0.04; %0.311= width of the geometry_calib interface (units relative to the srcreen)
 pos(2)=pos(2)-0.02;
-[FileName,RootPath,FileBase,FileIndices,FileExt,SubDir]=read_file_boxes(handles);
+%[FileName,RootPath,FileBase,FileIndices,FileExt,SubDir]=read_file_boxes(handles);
+[RootPath,SubDir,RootFile,FileIndices,FileExt]=read_file_boxes(handles);
+FileName=[fullfile(RootPath,SubDir,RootFile) FileIndices FileExt];
 set(handles.view_xml,'Backgroundcolor',[1 1 0])%indicate the reading of the current xml file by geometry_calib
 if isfield(UvData.OpenParam,'CalOrigin')
@@ -4687,5 +4657,6 @@
     masknumber=num2str(length(list));
     maskindex=get(handles.masklevel,'Value');
-    mask_name=name_generator([filebase '_' masknumber 'mask'],maskindex,1,'.png','_i');
+    mask_name=fullfile_uvmat(RootPath,SubDir,[RootFile '_' masknumber 'mask'],'.png','_1',maskindex);
+    %mask_name=name_generator([filebase '_' masknumber 'mask'],maskindex,1,'.png','_i');
     imflag=uint8(255*(0.392+0.608*flag));% =100 for flag=0 (vectors not computed when 20<imflag<200)
     imflag=flipdim(imflag,1);
@@ -4722,5 +4693,7 @@
 
 %prepare display of the set_grid GUI
-FileName=read_file_boxes(handles);
+[RootPath,SubDir,RootFile,FileIndices,FileExt]=read_file_boxes(handles);
+FileName=[fullfile(RootPath,SubDir,RootFile) FileIndices FileExt];
+%FileName=read_file_boxes(handles);
 CoordList=get(handles.transform_fct,'String');
 val=get(handles.transform_fct,'Value');
